/********************************************************************************/
/* File Name : CSPPlusParserForDevice.h											*/
/* Outline   : CSPPlusParserForDevice class definition							*/
/********************************************************************************/
#pragma once

#pragma pack(push,1) // ȑOɂ͒ǉȂ

#include <afxtempl.h>
#include <locale.h>
//<yVer.3_0001z 2019/10/10 MDIS Y.Matsushita [DTDΉ]>
//#import <msxml4.dll>
#import <msxml6.dll> \
	exclude("_FILETIME","ISequentialStream")
//<yVer.3_0001z 2019/10/10 MDIS Y.Matsushita [DTDΉ]>

#ifdef DLL_API_EXP
   #define DLL_API  __declspec(dllexport)   // export DLL information
#else
   #define DLL_API  __declspec(dllimport)   // import DLL information
#endif 

extern "C" {

	#pragma region Pre define
	class CMSF_Profile_ProfileData;
	class CMSF_Profile_SectionInfo;
	class CMSF_Profile_PartInfo;
	class CMSF_Profile_ElemInfo;
	class CMSF_Profile_ItemInfo;
	class CMSF_Profile_PartInfo_Condition;
	class CMSF_Profile_ItemInfo_Indexed;
	#pragma endregion

	#pragma region Constant
	//[[f[^ʒ`]]
	#define MSFDEF_PROFILE_DATATYPE_NON_CHECK					0x00000000	//[`FbNȂ]
	#define MSFDEF_PROFILE_DATATYPE_ENUM						0x00000001	//[񋓌^]
	#define MSFDEF_PROFILE_DATATYPE_MULTIPLE					0x00000002	//[^(J}؂)]
	#define MSFDEF_PROFILE_DATATYPE_BRACKETS					0x00000003	//[^(Rʋ؂)]
	#define MSFDEF_PROFILE_DATATYPE_RANGE						0x00000004	//[͈͌^]
	#define MSFDEF_PROFILE_DATATYPE_STRING						0x00000005	//[^]
	#define MSFDEF_PROFILE_DATATYPE_STRUCT						0x00000006	//[\̌^]
	#define MSFDEF_PROFILE_DATATYPE_CONDITION					0x00000007	//[^]
	#define MSFDEF_PROFILE_DATATYPE_REQFLAG						0x00000008	//[NGXgtO^]
	#define MSFDEF_PROFILE_DATATYPE_RELATEDCOMM					0x00000009	//[RELATEDMETHOD^]
	#define MSFDEF_PROFILE_DATATYPE_DUMMY_DATA					0x0000000a	//[_~[f[^]
	#define MSFDEF_PROFILE_DATATYPE_REF_TARGET_VALUE			0x0000000b	//[Qƌ^(^[Qbgvf̃GWjAOc[̒l)]
	#define MSFDEF_PROFILE_DATATYPE_REF_TARGET_ITEM				0x0000000c	//[Qƌ^(^[Qbgvf̍)]
	#define MSFDEF_PROFILE_DATATYPE_REF_STRUCT_ELEM_ADDRESS		0x0000000d	//[Qƌ^(\̗vf̃AhX)]
	#define MSFDEF_PROFILE_DATATYPE_REF_PART					0x0000000e	//[Qƌ^(p[g)]
	#define MSFDEF_PROFILE_DATATYPE_REF_ELEM					0x0000000f	//[Qƌ^(vf)]
	#define MSFDEF_PROFILE_DATATYPE_REF_ITEM					0x00000010	//[Qƌ^()]
	#define MSFDEF_PROFILE_DATATYPE_REF_TARGET_ALL_VALUE		0x00000011	//[Qƌ^(^[Qbgvf̑Svf̃GWjAOc[̒l)]
	#define MSFDEF_PROFILE_DATATYPE_REF_TARGET_ALL_ITEM			0x00000012	//[Qƌ^(^[Qbgvf̑Svf̍)]
	#define MSFDEF_PROFILE_DATATYPE_REF_TARGET_ITEM_SIZE		0x00000013	//[Qƌ^(^[Qbgvf̍ڂ̃f[^TCY)]
	#define MSFDEF_PROFILE_DATATYPE_CONDITION_REF				0x00000014	//[CONDITIONp[gQƌ^]
	#define MSFDEF_PROFILE_DATATYPE_REF_VALUE					0x00000015	//[Qƌ^(GWjAOc[̒l)]
	#define MSFDEF_PROFILE_DATATYPE_CRC32_1						0x00000016	//[CRC32_1^]
	#define MSFDEF_PROFILE_DATATYPE_CRC32_2						0x00000017	//[CRC32_2^]
	
	/*******************************************************/
	/* vt@CANZX@\NX̗OpG[R[h  */
	/* MSFERR_PROFILE_BASE + 0xE000ȍ~gp		   */
	/*******************************************************/
	#define MSFERR_PROFILE_BASE								0xF3050000						// vt@CT[rX
	#define MSFERR_PROFILE_EXCEPTION_FILENOTFOUND			(MSFERR_PROFILE_BASE + 0xE001)	//[CSP+t@CȂ]
	#define MSFERR_PROFILE_EXCEPTION_RANGE					(MSFERR_PROFILE_BASE + 0xE002)	//[̎w肪]
	#define MSFERR_PROFILE_EXCEPTION_INVALID_VERSION		(MSFERR_PROFILE_BASE + 0xE003)	//[CSP+t@CLqdlo[WɖΉ]
	#define MSFERR_PROFILE_EXCEPTION_MEMORY					(MSFERR_PROFILE_BASE + 0xE004)	//[mۂɎs]
	#define MSFERR_PROFILE_EXCEPTION_FILELOAD				(MSFERR_PROFILE_BASE + 0xE005)	//[CSP+t@C̉͂Ɏs]
	#define MSFERR_PROFILE_EXCEPTION_INVALID_DESCRIPTION	(MSFERR_PROFILE_BASE + 0xE006)	//[CSP+t@C̋Lqُ]
	#define MSFERR_PROFILE_EXCEPTION_INVALID_APICALL		(MSFERR_PROFILE_BASE + 0xE007)	//[ĂяoAPI]

	#ifndef SAFE_DELMEMFREE
	#define SAFE_DELMEMFREE(p)\
		if( (p)!= NULL )\
		{\
			delete (p);\
			(p) = NULL;\
		}
	#endif
	#pragma endregion

	#pragma region Enum
	/***f[^ANZX@\p`***/
	//[[ZNV]]
	//[NXCMSF_Profile_ProfileDataɂ镶zƂ̑Ή𒍈ӂĂ]
	enum EMSFDEF_PROFILE_SECTIONTYPE
	{
		EMSFDEF_PROFILE_SECTIONTYPE_UNKOWN = 0,		//[mZNV]
		EMSFDEF_PROFILE_SECTIONTYPE_FILE,			//[FILEZNV]
		EMSFDEF_PROFILE_SECTIONTYPE_DEVICE,			//[DEVICEZNV]
		EMSFDEF_PROFILE_SECTIONTYPE_BLOCK,			//[BLOCKZNV]
		EMSFDEF_PROFILE_SECTIONTYPE_COMMIF,			//[COMMIFZNV]
		//[ǉeȏɂĂ]
		EMSFDEF_PROFILE_SECTIONTYPE_MAX				//[ENUME]
	};

	//[[p[g]]
	//[NXCMSF_Profile_ProfileDataɂ镶zƂ̑Ή𒍈ӂĂ]
	enum EMSFDEF_PROFILE_PARTTYPE
	{
		EMSFDEF_PROFILE_PARTTYPE_UNKOWN = 0,		//[mp[g]
		EMSFDEF_PROFILE_PARTTYPE_FILE_INFO,			//[FILE_INFOp[g]
		EMSFDEF_PROFILE_PARTTYPE_DEVICE_INFO,		//[DEVICE_INFOp[g]
		EMSFDEF_PROFILE_PARTTYPE_BLOCK_INFO,		//[BLOCK_INFOp[g]
		EMSFDEF_PROFILE_PARTTYPE_BLOCK_INPUT,		//[BLOCK_INPUTp[g]
		EMSFDEF_PROFILE_PARTTYPE_BLOCK_OUTPUT,		//[BLOCK_OUTPUTp[g]
		EMSFDEF_PROFILE_PARTTYPE_BLOCK_PARAMETER,	//[BLOCK_PARAMETERp[g]
		EMSFDEF_PROFILE_PARTTYPE_BLOCK_COMMAND,		//[BLOCK_COMMANDp[g]
		EMSFDEF_PROFILE_PARTTYPE_COMMIF_INFO,		//[COMMIF_INFOp[g]
		EMSFDEF_PROFILE_PARTTYPE_COMMIF_INPUT,		//[COMMIF_INPUTp[g]
		EMSFDEF_PROFILE_PARTTYPE_COMMIF_OUTPUT,		//[COMMIF_OUTPUTp[g]
		EMSFDEF_PROFILE_PARTTYPE_COMMIF_PARAMETER,	//[COMMIF_PARAMETERp[g]
		EMSFDEF_PROFILE_PARTTYPE_COMMIF_COMMAND,	//[COMMIF_COMMANDp[g]
		EMSFDEF_PROFILE_PARTTYPE_METHOD,			//[METHODp[g]
		EMSFDEF_PROFILE_PARTTYPE_MESSAGE,			//[MESSAGEp[g]
		EMSFDEF_PROFILE_PARTTYPE_STRUCT,			//[STRUCTp[g]
		EMSFDEF_PROFILE_PARTTYPE_ENUM,				//[ENUMp[g]
		EMSFDEF_PROFILE_PARTTYPE_SELECT,			//[SELECTp[g]
		EMSFDEF_PROFILE_PARTTYPE_COMMAND_ARGUMENT,	//[COMMAND_ARGUMENTp[g]
		EMSFDEF_PROFILE_PARTTYPE_CONDITION,			//[CONDITIONp[g]
		//[ǉeȏɂĂ]
		EMSFDEF_PROFILE_PARTTYPE_MAX				//[ENUME]
	};

	//[[ڎ]]
	//[NXCMSF_Profile_ProfileDataɂ镶zƂ̑Ή𒍈ӂĂ]
	enum EMSFDEF_PROFILE_ITEMTYPE
	{
		EMSFDEF_PROFILE_ITEMTYPE_UNKOWN = 0,		//[m]
		EMSFDEF_PROFILE_ITEMTYPE_LABEL,				//[LABEL]
		EMSFDEF_PROFILE_ITEMTYPE_LABEL2,			//[LABEL2]
		EMSFDEF_PROFILE_ITEMTYPE_CATEGORY,			//[CATEGORY]
		EMSFDEF_PROFILE_ITEMTYPE_NAME,				//[NAME]
		//[ȏ͋ʍ]
		EMSFDEF_PROFILE_ITEMTYPE_DATATYPE,			//[DATATYPE]
		EMSFDEF_PROFILE_ITEMTYPE_DATA,				//[DATA]
		EMSFDEF_PROFILE_ITEMTYPE_DEFAULT,			//[DEFAULT]
		EMSFDEF_PROFILE_ITEMTYPE_RANGE,				//[RANGE]
		EMSFDEF_PROFILE_ITEMTYPE_MIN_INC,			//[MIN_INC]
		EMSFDEF_PROFILE_ITEMTYPE_ENG_UNIT,			//[ENG_UNIT]
		EMSFDEF_PROFILE_ITEMTYPE_ACCESS,			//[ACCESS]
		EMSFDEF_PROFILE_ITEMTYPE_EDIT,				//[EDIT]
		EMSFDEF_PROFILE_ITEMTYPE_ASSIGN,			//[ASSIGN]
		EMSFDEF_PROFILE_ITEMTYPE_UI_ATTRIBUTE,		//[UI_ATTRIBUTE]
		EMSFDEF_PROFILE_ITEMTYPE_WRITE_ORDER,		//[WRITE_ORDER]
		EMSFDEF_PROFILE_ITEMTYPE_ARGUMENT,			//[ARGUMENT]
		EMSFDEF_PROFILE_ITEMTYPE_OFFSET,			//[OFFSET]
		EMSFDEF_PROFILE_ITEMTYPE_CODE,				//[CODE]
		EMSFDEF_PROFILE_ITEMTYPE_REF,				//[REF]
		EMSFDEF_PROFILE_ITEMTYPE_ELE_NUM,			//[ELE_NUM]
		//[ȉMETHODMESSAGE]
		EMSFDEF_PROFILE_ITEMTYPE_TARGET,			//[TARGET]
		EMSFDEF_PROFILE_ITEMTYPE_METHOD_TYPE,		//[METHOD_TYPE]
		EMSFDEF_PROFILE_ITEMTYPE_WRITE_REGISTER,	//[WRITE_REGISTER]
		EMSFDEF_PROFILE_ITEMTYPE_WRITE_DATA,		//[WRITE_DATA]
		EMSFDEF_PROFILE_ITEMTYPE_WRITE_DATATYPE,	//[WRITE_DATATYPE]
		EMSFDEF_PROFILE_ITEMTYPE_READ_REGISTER,		//[READ_REGISTER]
		EMSFDEF_PROFILE_ITEMTYPE_READ_DATA,			//[READ_DATA]
		EMSFDEF_PROFILE_ITEMTYPE_READ_DATATYPE,		//[READ_DATATYPE]
		EMSFDEF_PROFILE_ITEMTYPE_INTERLOCK,			//[INTERLOCK]
		EMSFDEF_PROFILE_ITEMTYPE_REQ_FLAG,			//[REQ_FLAG]
		EMSFDEF_PROFILE_ITEMTYPE_END_CONDITION,		//[END_CONDITION]
		EMSFDEF_PROFILE_ITEMTYPE_ERR_CONDITION,		//[ERR_CONDITION]
		EMSFDEF_PROFILE_ITEMTYPE_ERR_REGISTER,		//[ERR_REGISTER]
		EMSFDEF_PROFILE_ITEMTYPE_INTER_REQ,			//[INTER_REQ]
		EMSFDEF_PROFILE_ITEMTYPE_INTER_ANS,			//[INTER_ANS]
		EMSFDEF_PROFILE_ITEMTYPE_RELATED_METHOD,	//[RELATED_METHOD]
		EMSFDEF_PROFILE_ITEMTYPE_MESSAGE_TYPE,		//[MESSAGE_TYPE]
		EMSFDEF_PROFILE_ITEMTYPE_MESSAGE_CODE,		//[MESSAGE_CODE]
		EMSFDEF_PROFILE_ITEMTYPE_REQUEST_AREA,		//[REQUEST_AREA]
		EMSFDEF_PROFILE_ITEMTYPE_REQUEST_DATA,		//[REQUEST_DATA]
		EMSFDEF_PROFILE_ITEMTYPE_REQUEST_DATATYPE,	//[REQUEST_DATATYPE]
		EMSFDEF_PROFILE_ITEMTYPE_RESPONSE_AREA,		//[RESPONSE_AREA]
		EMSFDEF_PROFILE_ITEMTYPE_RESPONSE_DATA,		//[RESPONSE_DATA]
		EMSFDEF_PROFILE_ITEMTYPE_RESPONSE_DATATYPE,	//[RESPONSE_DATATYPE]
		EMSFDEF_PROFILE_ITEMTYPE_RELATED_MESSAGE,	//[RELATED_MESSAGE]
		EMSFDEF_PROFILE_ITEMTYPE_ERR_CODE_RANGE,	//[ERR_CODE_RANGE]
		EMSFDEF_PROFILE_ITEMTYPE_REQUEST_TYPE,		//[REQUEST_TYPE]
		EMSFDEF_PROFILE_ITEMTYPE_RESPONSE_TYPE,		//[RESPONSE_TYPE]
		EMSFDEF_PROFILE_ITEMTYPE_ERR_TYPE,			//[ERR_TYPE]
		EMSFDEF_PROFILE_ITEMTYPE_TYPE,				//[TYPE]
		EMSFDEF_PROFILE_ITEMTYPE_RELATED_ELE,		//[RELATED_ELE]
		EMSFDEF_PROFILE_ITEMTYPE_CONDITIONXVARIABLE,//[CONDITIONXVARIABLE]
		EMSFDEF_PROFILE_ITEMTYPE_CONDITIONX,		//[CONDITIONX]
		EMSFDEF_PROFILE_ITEMTYPE_RESULTX,			//[RESULTX]
		EMSFDEF_PROFILE_ITEMTYPE_COMMENT,			//[COMMENT]
		EMSFDEF_PROFILE_ITEMTYPE_REMARK,			//[REMARK]]
		//[ǉeȏɂĂ]
		EMSFDEF_PROFILE_ITEMTYPE_MAX				//[ENUME]
	};

	//[[f[^]]
	//[ڃf[^擾ݒ]
	enum EMSFDEF_PROFILE_GETITEMTYPE
	{
		EMSFDEF_PROFILE_GETITEMTYPE_NONE = 0,		//[Ȃ]
		EMSFDEF_PROFILE_GETITEMTYPE_RECURSIVE =2	//[ċAIɎ擾]
	};

	//[[͈͌^f[^̐^Cv]]
	enum ELIMITTYPE
	{
		MSFDEF_PROFILE_LIMITTYPE_NON = 0,			//[El̎wȂ]
		MSFDEF_PROFILE_LIMITTYPE_LESS,				//[Ȃi<j]
		MSFDEF_PROFILE_LIMITTYPE_GREATER,			//[Ȃi>j]
		MSFDEF_PROFILE_LIMITTYPE_LESSEQUAL,			//[ȂCR[i<=j]
		MSFDEF_PROFILE_LIMITTYPE_GREATEREQUAL		//[ȂCR[i>=j]
	};

	//[Zq]
	enum EOPERATORTYPE
	{
		MSFDEF_PROFILE_OPERATORTYPE_NON = 0,		//[ZqwȂ]
		MSFDEF_PROFILE_OPERATORTYPE_REQEQUAL,		//[i=j]
		MSFDEF_PROFILE_OPERATORTYPE_EQUAL,			//[i==j]
		MSFDEF_PROFILE_OPERATORTYPE_NOTEQUAL,		//[si!=j]
		MSFDEF_PROFILE_OPERATORTYPE_LESS,			//[Ȃi<j]
		MSFDEF_PROFILE_OPERATORTYPE_GREATER,		//[Ȃi>j]
		MSFDEF_PROFILE_OPERATORTYPE_LESSEQUAL,		//[ȂCR[i<=j]
		MSFDEF_PROFILE_OPERATORTYPE_GREATEREQUAL	//[ȂCR[i>=j]
	};

	//[RELATED_METHOD/RELATED_MESSAGE^f[^]
	enum ERELATEDTYPE
	{
		MSFDEF_PROFILE_RELATEDTYPE_PRE = 1,			//[PRE METHOD]
		MSFDEF_PROFILE_RELATEDTYPE_INTER,			//[INTER METHOD]
		MSFDEF_PROFILE_RELATEDTYPE_POST,			//[POST METHOD]
		MSFDEF_PROFILE_RELATEDTYPE_SEQ				//[SEQ METHOD]
	};
	#pragma endregion

	#pragma region Structure
	//[\̒`]
	typedef CArray<CMSF_Profile_SectionInfo*, CMSF_Profile_SectionInfo*&> CMSF_Profile_SectionInfoArray;
	typedef CArray<CMSF_Profile_PartInfo*, CMSF_Profile_PartInfo*&> CMSF_Profile_PartInfoArray;
	typedef CArray<CMSF_Profile_ElemInfo*, CMSF_Profile_ElemInfo*&> CMSF_Profile_ElemInfoArray;
	typedef CArray<CMSF_Profile_ItemInfo*, CMSF_Profile_ItemInfo*&> CMSF_Profile_ItemInfoArray;
	typedef CArray<CMSF_Profile_ItemInfo_Indexed*, CMSF_Profile_ItemInfo_Indexed*&> CMSF_Profile_ItemInfo_ConditionArray;
	//[͈͌^f[^]
	typedef struct _ST_MSF_PROFILE_RANGE_DATA 
	{
		public:
			CString		strMinData;					// [ŏl]
			ELIMITTYPE	dwMinType;					// [ŏl^Cv]
			CString		strMaxData;					// [ől]
			ELIMITTYPE	dwMaxType;					// [ől^Cv]
			CMSF_Profile_ItemInfo*	pMinItemInfo;	// [ŏl̍]
			CMSF_Profile_ItemInfo*	pMaxItemInfo;	// [ől̍]
			//[RXgN^]
			DLL_API _ST_MSF_PROFILE_RANGE_DATA();
	} ST_MSF_PROFILE_RANGE_DATA, *PST_MSF_PROFILE_RANGE_DATA;

	//[nhVFCN^f[^]
	typedef struct _ST_MSF_PROFILE_HANDSHAKING_DATA 
	{
		CString	strAddress;				// [AhX]
		EOPERATORTYPE	eOperator;		// [Zq]
		LONG	lConditonValue;			// [l]
	} ST_MSF_PROFILE_HANDSHAKING_DATA, *PST_MSF_PROFILE_HANDSHAKING_DATA;

	//[RELATED COMM DATA\̒`]
	typedef struct _ST_MSF_PROFILE_RELATEDCOMM_DATA
	{
		DWORD dwRelatedType;
		CMSF_Profile_ItemInfo* pMethod;
	} ST_MSF_PROFILE_RELATEDCOMM_DATA, *PST_MSF_PROFILE_RELATEDCOMM_DATA;

	//[NGXgtO^f[^]
	typedef struct _ST_MSF_PROFILE_REQFLAG_DATA 
	{
		CMSF_Profile_ItemInfo*	pAddress;		// [AhX]
		EOPERATORTYPE	eOperator;				// [Zq]
		LONG	lValue;							// [l]
	} ST_MSF_PROFILE_REQFLAG_DATA, *PST_MSF_PROFILE_REQFLAG_DATA;

	//[ƌʃf[^]
	typedef struct _ST_MSF_PROFILE_CONDITION_RESULT_DATA 
	{
		CMSF_Profile_ItemInfo_ConditionArray	cConditionInfoArray;	// [ꗗ]
		CMSF_Profile_ItemInfo_Indexed*		pResultItemInfo;			// []
		//[RXgN^]
		DLL_API _ST_MSF_PROFILE_CONDITION_RESULT_DATA();
		// [operator=]
		DLL_API _ST_MSF_PROFILE_CONDITION_RESULT_DATA &operator=(const _ST_MSF_PROFILE_CONDITION_RESULT_DATA &stConditionResultData);

	} ST_MSF_PROFILE_CONDITION_RESULT_DATA, *PST_MSF_PROFILE_CONDITION_RESULT_DATA;

	//[Q()^f[^]
	typedef struct _ST_MSF_PROFILE_CONDITION_REF_DATA 
	{
		CMSF_Profile_ElemInfoArray	cConditionRefElemArray;								// [ϐꗗ]
		CArray<ST_MSF_PROFILE_CONDITION_RESULT_DATA>	cstConditionResultDataArray;	// [ƌʂ̈ꗗ]
	} ST_MSF_PROFILE_CONDITION_REF_DATA, *PST_MSF_PROFILE_CONDITION_REF_DATA;
	#pragma endregion

	#pragma region Analyser
	namespace ProfileInnerConst
	{
		#pragma region Constant & Structure
		//[ڃf[^̍\̒`]
		typedef struct _ST_MSF_PROFILE_DATAINFO {
			DWORD dwDataType;
			CString strValue;
		} ST_MSF_PROFILE_DATAINFO, *PST_MSF_PROFILE_DATAINFO;
	
		//[RELATED COMM STR\̒`]
		typedef struct _ST_MSF_PROFILE_RELATEDCOMM_STR
		{
			DWORD dwRelatedType;
			CString strMethodName;
		} ST_MSF_PROFILE_RELATEDCOMM_STR, *PST_MSF_PROFILE_RELATEDCOMM_STR;

		typedef CArray<ST_MSF_PROFILE_DATAINFO, ST_MSF_PROFILE_DATAINFO&> ST_MSF_PROFILE_DATAINFO_ARRAY;
		#pragma endregion
		
		#pragma region Class
		/********************************************************************************/
		/* Class Name : CProfile_Lexical_Analyser										*/
		/* Outline    : The phrase analysis engine										*/
		/********************************************************************************/
		class  CProfile_Lexical_Analyser
		{
		public:
			DWORD m_dwItemType;
			CString m_strDataInfo;
			CProfile_Lexical_Analyser(void);
			~CProfile_Lexical_Analyser(void){}
		private:
			
			INT_PTR _ComParePriority(const CString strOperator);
		public:
			
			DWORD CheckDataType(void);
			
			BOOL CheckExistingAsterisk(void);
			
			DWORD CheckRelatedComm(void);
			
			ST_MSF_PROFILE_RANGE_DATA RangeAnalyze(void);
			
			CString EscSeqAnalyze(void);
			
			void BracketsAnalyze(CArray<CString>& rstrItemInfoArray);
			
			void DollarAnalyze(CArray<CString, CString&> &resultValue);
			
			void RefNotationAnalyze(CString strvalue, CArray<CString, CString&> &resultValue);
			
			ST_MSF_PROFILE_HANDSHAKING_DATA ReqFlagAnalyze(void);
			
			void ConditionNotationAnalyze(CArray<CString>& strValueArray);
			
			CString CaluclateBitRegister(CString strAddressInfo, CString strOffsetInfo);
			
			ST_MSF_PROFILE_RELATEDCOMM_STR RelatedMethodAnalyze(void);
			
			BOOL CheckBeginAndEnd(CString strDataInfo, CString strBegin, CString strEnd);
		};
		#pragma endregion
	}
	#pragma endregion Use for internal only

	#pragma region Exported Class

	#pragma region CMSF_Profile_ExceptionBase Class
	/********************************************************************************/
	/* Class Name : CMSF_Profile_ExceptionBase										*/
	/* Outline    : Base class of access anomaly class								*/
	/********************************************************************************/
	class CMSF_Profile_ExceptionBase
	{
	public:	

		#pragma region Exported API
		DLL_API CMSF_Profile_ExceptionBase(void);
		DLL_API virtual ~CMSF_Profile_ExceptionBase(void) {}

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetErrCode												*/
		/* Outline       : Get error code									    	*/
		/* Parameter     : None														*/
		/* Return Value  : Error code									    		*/
		/*																			*/
		/****************************************************************************/
		DLL_API DWORD GetErrCode(void);
		#pragma endregion

		#pragma region For Internal
		void SetErrCode(
			const DWORD& errCode		// [IN] G[bZ[W
			);

	protected:
		//[G[R[h]
		DWORD m_dwErrCode;
		#pragma endregion
	};
	#pragma endregion

	#pragma region CMSF_Profile_ItemInfo Class
	/********************************************************************************/
	/* Class Name : CMSF_Profile_ItemInfo											*/
	/* Outline    : Item class														*/
	/********************************************************************************/
	class CMSF_Profile_ItemInfo
	{
	public:
		#pragma region Exported Properties
		DWORD m_dwItemType;
		CMSF_Profile_ElemInfo* m_Parent;
		#pragma endregion

		#pragma region Exported API
		DLL_API CMSF_Profile_ItemInfo(void);
		DLL_API ~CMSF_Profile_ItemInfo(void){}

		/********************************************************************************/
		/*																				*/
		/* Function Name : GetSize														*/
		/* Outline       : Get the bit size corresponding to the specified data size	*/
		/*					Corresponds to character strings and data types				*/
		/*					other than set among the data types defined in the profile	*/
		/* Parameter     : CString& strDataType: (IN)The specified data type			*/
		/* Return Value  : Data type bit size											*/
		/*																				*/
		/********************************************************************************/
		DLL_API static DWORD GetSize( 
			CString& strDataType					// [in]w肳ꂽf[^^
			);

 		/****************************************************************************/
		/*																			*/
		/* Function Name : GetDataTypeSize											*/
		/* Outline       : Get data size											*/
		/*					If no argument is specified or FALSE is specified, 		*/
		/*					the word size is returned.								*/
		/*					Only instances of DATATYPE item are available.			*/
		/* Parameter     : BOOL bBitSize: (IN)Whether the bit size					*/
		/* Return Value  : Data size												*/
		/*																			*/
		/****************************************************************************/
		 DLL_API DWORD GetDataTypeSize( 
			BOOL bBitSize = FALSE					// [in]rbgTCYǂ
			);

		/************************************************************************************/
		/*																					*/
		/* Function Name : GetTargetDataTypeSize											*/
		/* Outline       : Get the data size of the reference destination (DATATYPE item)	*/
		/*					of the item of the element specified by TARGET.					*/
		/* Parameter     : CMSF_Profile_ElemInfo* pcElemInfo:(IN)The specified element		*/
		/* Return Value  : Data size of reference destination (DATATYPE item)				*/
		/*																					*/
		/************************************************************************************/
		 DLL_API DWORD GetTargetDataTypeSize( 
			CMSF_Profile_ElemInfo* pcElemInfo					// [in]TARGETŎw肳Ăvf
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : CheckDataType											*/
		/* Outline       : Check data type											*/
		/* Parameter     : None														*/
		/* Return Value  : Data type												*/
		/*																			*/
		/****************************************************************************/
		DLL_API DWORD CheckDataType(
			void
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetRawData												*/
		/* Outline       : Get descriptive data										*/
		/* Parameter     : None														*/
		/* Return Value  : String data												*/
		/*																			*/
		/****************************************************************************/
		DLL_API CString GetRawData(
			void
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetStringData											*/
		/* Outline       : Get string type data										*/
		/* Parameter     : None														*/
		/* Return Value  : String type data											*/
		/*																			*/
		/****************************************************************************/
		DLL_API CString GetStringData(
			void
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetEnumData												*/
		/* Outline       : Get enumerated data										*/
		/* Parameter     : None														*/
		/* Return Value  : Pointer to enumerated data								*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_PartInfo* GetEnumData(
			void
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetConditionRefInfo										*/
		/* Outline       : Get condition part reference type data					*/
		/* Parameter     : int* piResultNo	:(OUT)Result No							*/
		/* Return Value  : Pointer of the condition part which is referencing		*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_PartInfo_Condition* GetConditionRefInfo(
			int* piResultNo
			);

		/********************************************************************************/
		/*																				*/
		/* Function Name : GetConditionRefInfo											*/
		/* Outline       : Get reference (conditional expression) type data				*/
		/* Parameter     : stConditionRefData	:(OUT)Reference (conditional) type data	*/
		/* Return Value  : None															*/
		/*																				*/
		/********************************************************************************/
		DLL_API void GetConditionRefInfo(
			ST_MSF_PROFILE_CONDITION_REF_DATA& stConditionRefData
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetValueInfo												*/
		/* Outline       : Get a reference destination (element) of a value			*/
		/*					on the engineering tool									*/
		/* Parameter     : None														*/
		/* Return Value  : Reference destination of the value on the engineering tool (element)	*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_ElemInfo* CMSF_Profile_ItemInfo::GetValueInfo(void);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetRangeData												*/
		/* Outline       : Get range type data										*/
		/* Parameter     : None														*/
		/* Return Value  : Range type data											*/
		/*																			*/
		/****************************************************************************/
		DLL_API ST_MSF_PROFILE_RANGE_DATA GetRangeData(
			void
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetStructData											*/
		/* Outline       : Get part type data										*/
		/* Parameter     : None														*/
		/* Return Value  : Pointer of part type data								*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_PartInfo* GetStructData(
			void
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetMultipleData											*/
		/* Outline       : Get multiple data (comma separated values)				*/
		/* Parameter     : CMSF_Profile_ItemInfoArray& rclsItemInfoArray			*/
		/*							:(OUT)Array of multiple data (comma separated values)	*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API void GetMultipleData(
			CMSF_Profile_ItemInfoArray& rclsItemInfoArray	// [out] f[^(J}؂)̔z
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetBracketsData											*/
		/* Outline       : Get multiple data (parenthesized break)					*/
		/* Parameter     : CMSF_Profile_ItemInfoArray& rclsItemInfoArray			*/
		/*							:(OUT)Array of multiple data (parenthesized break)	*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API void GetBracketsData(
			CMSF_Profile_ItemInfoArray& rclsItemInfoArray	// [out] f[^(ʋ؂)̔z
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetTargetRefItem											*/
		/* Outline       : In the item of the method part, get the reference destination (item)	*/
		/*					of the item of the element specified by TARGET			*/
		/* Parameter     : CMSF_Profile_ElemInfo* elemInfo							*/
		/*							:(OUT)Item of specified element					*/
		/* Return Value  : Reference destination (item) of the item of the element specified by TARGET	*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_ItemInfo* GetTargetRefItem(
			CMSF_Profile_ElemInfo* elemInfo			// [out] w肳Ăvf̍
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetTargetValueInfo										*/
		/* Outline       : In the item of the method part, get the reference destination (element)	*/
		/*					of the item of the element specified by TARGET			*/
		/* Parameter     : CMSF_Profile_ElemInfo* pElemInfo							*/
		/*							:(IN)The specified element						*/
		/* Return Value  : Reference destination (element) of the item 				*/
		/*					of the element specified by TARGET						*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_ElemInfo* GetTargetValueInfo(
			CMSF_Profile_ElemInfo* pElemInfo			// [in] w肳Ăvf
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetTargetAllRefItems										*/
		/* Outline       : Get items of all elements specified by TARGET			*/
		/* Parameter     : CMSF_Profile_ItemInfoArray* rclsItemInfoArray			*/
		/*							:(OUT)Items of all specified elements			*/
		/*					CMSF_Profile_ItemInfo* pcTargetItem						*/
		/*							:(IN)The specified TARGET item					*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API void GetTargetAllRefItems(
			CMSF_Profile_ItemInfoArray& rclsItemInfoArray,			// [out]w肳ĂSĂ̗vf̍
			CMSF_Profile_ItemInfo* pcTargetItem = NULL				// [in]w肳ĂTARGET
			);
		/****************************************************************************/
		/*																			*/
		/* Function Name : GetTargetAllRefItems										*/
		/* Outline       : Get items of all elements specified by TARGET			*/
		/* Parameter     : CMSF_Profile_ItemInfoArray* rclsItemInfoArray			*/
		/*							:(OUT)Items of all specified elements			*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API void GetTargetAllRefItems(
			CMSF_Profile_ElemInfoArray& rclcElemInfoArray,			// [in]TargetڂŎQƂĂSĂ̗vf
			CMSF_Profile_ItemInfoArray& rclsItemInfoArray			// [out]w肳ĂSĂ̗vf̍
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetTargetAllValueInfo									*/
		/* Outline       : Get all elements specified by TARGET						*/
		/*					(Acquire element as information for linking engineering tool	*/
		/*						and profile)										*/
		/* Parameter     : CMSF_Profile_ElemInfoArray& rclsElemInfoArray			*/
		/*							:(OUT)All specified elements					*/
		/*					CMSF_Profile_ItemInfo* pcTargetItem						*/
		/*							:(IN)The specified TARGET item					*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API void GetTargetAllValueInfo(
			CMSF_Profile_ElemInfoArray& rclsElemInfoArray,			// [out]w肳ĂSĂ̗vf
			CMSF_Profile_ItemInfo* pcTargetItem = NULL				// [in]w肳ĂTARGET
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetConditionData											*/
		/* Outline       : Get condition expression data in reverse Polish notation order	*/
		/* Parameter     : CMSF_Profile_ItemInfoArray&								*/
		/*						rclsItemInfoArray	:(OUT)Array for obtaining conditional expression data	*/
		/*													in reverse Polish notation order	*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API void GetConditionData(
			CMSF_Profile_ItemInfoArray& rclsItemInfoArray	//[out]f[^t|[hL@̏Ŏ擾z
			);
		/****************************************************************************/
		/*																			*/
		/* Function Name : GetReqFlagData											*/
		/* Outline       : Get the data as a structure of REQ_FLAG					*/
		/* Parameter     : None														*/
		/* Return Value  : ST_MSF_PROFILE_REQFLAG_DATA								*/
		/*																			*/
		/****************************************************************************/
		DLL_API ST_MSF_PROFILE_REQFLAG_DATA GetReqFlagData(void);


		/****************************************************************************/
		/*																			*/
		/* Function Name : GetRelatedCommData										*/
		/* Outline       : Get related data											*/
		/* Parameter     : None														*/
		/* Return Value  : ST_MSF_PROFILE_RELATEDCOMM_DATA	Related data			*/
		/*																			*/
		/****************************************************************************/
		DLL_API ST_MSF_PROFILE_RELATEDCOMM_DATA GetRelatedCommData(void);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetRefPart												*/
		/* Outline       : Get a pointer to the part class with the specified label name	*/
		/* Parameter     : None														*/
		/* Return Value  : Pointer to part class									*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_PartInfo* GetRefPart(void);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetRefElem												*/
		/* Outline       : Get a pointer to the element class with the specified label name	*/
		/* Parameter     : None														*/
		/* Return Value  : Pointer to element class									*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_ElemInfo* GetRefElem(void);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetRefItem												*/
		/* Outline       : Get a pointer to the item class with the specified label name	*/
		/* Parameter     : None														*/
		/* Return Value  : Pointer to item class									*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_ItemInfo* GetRefItem(void);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetRefStructElemAddress									*/
		/* Outline       : Get the structure element address of the referenced element	*/
		/* Parameter     : None														*/
		/* Return Value  : Structure element address of referenced element			*/
		/*																			*/
		/****************************************************************************/
		DLL_API CString GetRefStructElemAddress(
			CMSF_Profile_ElemInfo*& rpRefElemInfo
			);
		#pragma endregion

		#pragma region For Internal
		void GetProfileItem(CMSF_Profile_ItemInfo* pcTempItem);
		INT GetDataListCount();
		ProfileInnerConst::ST_MSF_PROFILE_DATAINFO GetData(INT nIndex);
		void Add(ProfileInnerConst::ST_MSF_PROFILE_DATAINFO& dataInfo);

	private:
		ProfileInnerConst::ST_MSF_PROFILE_DATAINFO_ARRAY m_DataList;
		ProfileInnerConst::CProfile_Lexical_Analyser m_LexicalAnalyser;
		DWORD m_dwDataType;

		CMSF_Profile_ItemInfo* _GetItem(CString strItemLabel, CMSF_Profile_ElemInfo* pElemInfo);
		CMSF_Profile_ItemInfo* _GetTargetItem(CString strItemLabel, CMSF_Profile_ElemInfo* pElemInfo);
		void _GetTargetRefElems(CMSF_Profile_ElemInfoArray& rclsElemInfoArray,CMSF_Profile_ItemInfo* pcTarget = NULL);
		#pragma endregion
	};
	#pragma endregion

	#pragma region CMSF_Profile_ItemInfo_Indexed Class
	/********************************************************************************/
	/* Class Name : CMSF_Profile_ItemInfo_Indexed									*/
	/* Outline    : Item class of the condition part								*/
	/********************************************************************************/
	class  CMSF_Profile_ItemInfo_Indexed:public CMSF_Profile_ItemInfo
	{
	public:
		#pragma region Exported Properties
		//[CONDITIONxڂ܂RESULTxڂ̃CfbNX]
		DWORD m_dwIndex;
		#pragma endregion

		#pragma region Exported API
		DLL_API CMSF_Profile_ItemInfo_Indexed(void){}
		DLL_API ~CMSF_Profile_ItemInfo_Indexed(void){}
		#pragma endregion
	};

	#pragma endregion

	#pragma region CMSF_Profile_ElemInfo Class
	/********************************************************************************/
	/* Class Name : CMSF_Profile_ElemInfo											*/
	/* Outline    : Element class													*/
	/********************************************************************************/
	class CMSF_Profile_ElemInfo
	{

	public:
		#pragma region Exported Properties
		//[x]
		CString m_strLabel;
		//[ep[g̃|C^]
		CMSF_Profile_PartInfo* m_Parent;
		#pragma endregion

		#pragma region Exported API
		DLL_API CMSF_Profile_ElemInfo(void);
		DLL_API ~CMSF_Profile_ElemInfo(void);

		/****************************************************************************/
		/*																			*/
		/* Function Name : Get														*/
		/* Outline       : Get all items											*/
		/* Parameter     : CMSF_Profile_ItemInfoArray& rclsItemInfoArray			*/
		/*							:(OUT)Array of pointers to all items class		*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API void Get(
			CMSF_Profile_ItemInfoArray& rclsItemInfoArray	// [out] SڃNXւ̃|C^̔z
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : Get														*/
		/* Outline       : Get the item with the item type specified				*/
		/* Parameter     : DWORD dwItemType	:(IN)Item type							*/
		/* Return Value  : Pointer to the item class of the specified item type		*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_ItemInfo* Get(
			DWORD dwItemType,						// [in] ڎ
			DWORD dwGetRecurrent = EMSFDEF_PROFILE_GETITEMTYPE_NONE	// [in] ċA擾ݒ
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetCommIFRef												*/
		/* Outline       : Get the element referenced in the REF item				*/
		/* Parameter     : None														*/
		/* Return Value  : Pointer of the element class referenced in the REF item	*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_ElemInfo* GetCommIFRef(
			void
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : ReleaseItemArray											*/
		/* Outline       : Release pointer array of item							*/
		/* Parameter     : CMSF_Profile_ItemInfoArray& rclsItemInfoArray			*/
		/*							:(OUT)Array of pointers to item classes			*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API static void ReleaseItemArray(
			CMSF_Profile_ItemInfoArray& rclsItemInfoArray	// [out] SڃNXւ̃|C^̔z
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : ReleaseConditionRefData									*/
		/* Outline       : Release of reference (conditional) type data structure	*/
		/* Parameter     : ST_MSF_PROFILE_CONDITION_REF_DATA& stConditionRefData	*/
		/*							:(IN)Array of pointers to item classes			*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API static void ReleaseConditionRefData(
			ST_MSF_PROFILE_CONDITION_REF_DATA& stConditionRefData	// [In] Q()^f[^\
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : CreateLabelPath											*/
		/* Outline       : Create a label path consisting of section label name, 	*/
		/*					pert label name, element label name						*/
		/* Parameter     : None														*/
		/* Return Value  : Label pass												*/
		/*																			*/
		/****************************************************************************/
		DLL_API CString CreateLabelPath();
		#pragma endregion

		#pragma region  For Internal
		void Add(CMSF_Profile_ItemInfo* pItemInfo);
		int GetSize();

	private:		
		CMSF_Profile_ItemInfoArray m_ItemList;
		#pragma endregion
	};

	#pragma endregion

	#pragma region CMSF_Profile_PartInfo Class
	/********************************************************************************/
	/* Class Name : CMSF_Profile_PartInfo											*/
	/* Outline    : Part class														*/
	/********************************************************************************/
	class CMSF_Profile_PartInfo
	{
	public:
		#pragma region Exported Properties
		// [p[gx]
		CString m_strLabel;
		// [p[gRg]
		CString m_strComment;
		// [p[g]
		DWORD m_dwPartType;
		// [eZNVւ̃|C^]
		CMSF_Profile_SectionInfo* m_Parent;
		// [p[gx2]
		CString m_strLabel2;
		#pragma endregion

		#pragma region Exported API
		DLL_API CMSF_Profile_PartInfo(void);
		DLL_API ~CMSF_Profile_PartInfo(void);

		/****************************************************************************/
		/*																			*/
		/* Function Name : Get														*/
		/* Outline       : Get all elements											*/
		/* Parameter     : CMSF_Profile_ElemInfoArray& rclsElemInfoArray			*/
		/*							:(OUT)An array of pointers to classes of all elements	*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API void Get(
			CMSF_Profile_ElemInfoArray& rclsElemInfoArray	// [out] Svf̃NXւ̃|C^̔z
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : Get														*/
		/* Outline       : Get element by specifying label name						*/
		/* Parameter     : CString strElemLabel	:(IN)Element label name				*/
		/* Return Value  : Pointer to the element class of the specified label name	*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_ElemInfo* Get(
			CString strElemLabel							// [in] vfx
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : GetItemList												*/
		/* Outline       : Retrieve the item with the item type specified			*/
		/* Parameter     : DWORD dwItemType	:(IN)Part type							*/
		/*				 : CMSF_Profile_ItemInfoArray& rclsItemInfoArray			*/
		/*							:(OUT)An array of pointers to item classes		*/
		/*									of the specified item type				*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API void GetItemList(
			DWORD dwItemType,								// [in] ڎ
			CMSF_Profile_ItemInfoArray& rclsItemInfoArray	// [out] w肳ꂽڎʂ̍ڃNXւ̃|C^̔z
			);
		#pragma endregion

		#pragma region  For Internal
		void Add(CMSF_Profile_ElemInfo* pElemInfo);
		VOID SetPartNode(MSXML2::IXMLDOMNodePtr pstPartNode);

	private:
		CMSF_Profile_ElemInfoArray m_ElemList;
		BOOL m_bElemCreated;
		MSXML2::IXMLDOMNodePtr m_pPartNode;
		
		BOOL _CreateElems();
		#pragma endregion
	};
	
	#pragma endregion

	#pragma region CMSF_Profile_PartInfo_Condition Class
	/********************************************************************************/
	/* Class Name : CMSF_Profile_PartInfo_Condition									*/
	/* Outline    : The class of the condition part									*/
	/********************************************************************************/
	class  CMSF_Profile_PartInfo_Condition:public CMSF_Profile_PartInfo
	{
	public:
		#pragma region Exported Properties
		// []
		DWORD m_dwConditionNumber;
		// [ʐ]
		DWORD m_dwResultNumber;	
		#pragma endregion

		#pragma region Exported API
		DLL_API CMSF_Profile_PartInfo_Condition(void){}
		DLL_API ~CMSF_Profile_PartInfo_Condition(void){}
		#pragma endregion
	};

	#pragma endregion

	#pragma region CMSF_Profile_SectionInfo Class
	/********************************************************************************/
	/* Class Name : CMSF_Profile_SectionInfo										*/
	/* Outline    : Section class													*/
	/********************************************************************************/
	class CMSF_Profile_SectionInfo
	{
	public:
		#pragma region Exported Properties
		// [ZNVx]
		CString m_strLabel;
		// [ZNVRg]
		CString m_strComment;
		// [ZNV]
		DWORD m_dwSectionType;
		// [eւ̃|C^]
		CMSF_Profile_ProfileData* m_Parent;
		#pragma endregion

		#pragma region Exported API
		DLL_API CMSF_Profile_SectionInfo(void);
		DLL_API ~CMSF_Profile_SectionInfo(void);
		
		/****************************************************************************/
		/*																			*/
		/* Function Name : Get														*/
		/* Outline       : Get all parts											*/
		/* Parameter     : CMSF_Profile_PartInfoArray rclsPartInfoArray				*/
		/*							:(OUT)Array of pointers to all part classes		*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API void Get(
			CMSF_Profile_PartInfoArray& rclsPartInfoArray		// [out] Sp[g̃NXւ̃|C^̔z
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : Get														*/
		/* Outline       : Get part with label name specified						*/
		/* Parameter     : CString strPartLabel	:(IN)Part label name				*/
		/* Return Value  : Pointer to the part class of the specified label name	*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_PartInfo* Get(
			CString strPartLabel								// [in] p[gx
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : Get														*/
		/* Outline       : Get the part that specifies the part type				*/
		/* Parameter     : DWORD dwPartType	:(IN)Part type							*/
		/*				 : CMSF_Profile_PartInfoArray rclsPartInfoArray				*/
		/*							:(OUT)An array of pointers to the part class	*/
		/*									of the specified part type				*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API void Get(
			DWORD dwPartType,								// [in] p[g
			CMSF_Profile_PartInfoArray& rclsPartInfoArray	// [out] w肳ꂽp[gʂ̃p[gNXւ̃|C^̔z
			);
		#pragma endregion

		#pragma region For Internal
		void Add(CMSF_Profile_PartInfo* pPartInfo);
	private:
		CMSF_Profile_PartInfoArray m_PartList;
		#pragma endregion
	};

	#pragma endregion

	#pragma region CMSF_Profile_ProfileData Class
	/********************************************************************************/
	/* Class Name : CMSF_Profile_ProfileData										*/
	/* Outline    : Profile data class												*/
	/********************************************************************************/
	class CMSF_Profile_ProfileData
	{
	public:
		#pragma region Exported Properties
		//[jbg`]
		CString m_strFormName;
		//[@o[W]
		CString m_strUnitVersion;
		//[vt@Cdlo[W]
		CString m_strFormatVersion;
		//[t@Co[W]
		CString m_strFileVersion;
		//[]
		CString m_strLanguage;
		//[vt@CpX]
		CString m_strProfilePath;
		//[vt@C]
		DWORD m_dwProfileType;
		#pragma endregion

		#pragma region Exported API
		/****************************************************************************/
		/*																			*/
		/* Function Name : CMSF_Profile_ProfileData									*/
		/* Outline       : Read the specified XML file								*/
		/* Parameter     : CString& strXMLFilePath									*/
		/*							:(IN)XML file path								*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API explicit CMSF_Profile_ProfileData(
			const CString& strXMLFilePath	// [IN] XMLt@CpX
			);

		/****************************************************************************/
		/*																			*/
		/* Function Name : ~CMSF_Profile_ProfileData								*/
		/* Outline       : Release the saved XML information array					*/
		/* Parameter     : None														*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API ~CMSF_Profile_ProfileData(void);

		/****************************************************************************/
		/*																			*/
		/* Function Name : Get														*/
		/* Outline       : Get all sections											*/
		/* Parameter     : CMSF_Profile_SectionInfoArray rclsSectionInfoArray		*/
		/*							:(OUT)Array of pointers to classes of all sections	*/
		/* Return Value  : None														*/
		/*																			*/
		/****************************************************************************/
		DLL_API void Get(
			CMSF_Profile_SectionInfoArray& rclsSectionInfoArray		// [out] SZNṼNXւ̃|C^̔z
			);
		/****************************************************************************/
		/*																			*/
		/* Function Name : Get														*/
		/* Outline       : Get a section by specifying a label name					*/
		/* Parameter     : CString strSectionLabel	:(IN)Section label name			*/
		/* Return Value  : Pointer to the section class with the specified label name	*/
		/*																			*/
		/****************************************************************************/
		DLL_API CMSF_Profile_SectionInfo* Get(
			CString strSectionLabel						// [in] ZNVx
			);
		/****************************************************************************/
		/*																			*/
		/* Function Name : Get														*/
		/* Outline       : Get a section with section type specified				*/
		/* Parameter     : DWORD dwSectionType	:(IN)Section type					*/
		/*				 : CMSF_Profile_SectionInfoArray rclsSectionInfoArray		*/
		/*							:(OUT)Array of pointers to classes of all sections	*/
		/* Return Value  : An array of pointers to the section class 				*/
		/*					of the specified section type							*/
		/*																			*/
		/****************************************************************************/
		DLL_API void Get(
			DWORD dwSectionType,									// [in] ZNV
			CMSF_Profile_SectionInfoArray& rclsSectionInfoArray		// [out] SZNṼNXւ̃|C^̔z
			);
		#pragma endregion

		#pragma region For Internal
		CMSF_Profile_ProfileData(const CString& strXMLFilePath,	const MSXML2::IXMLDOMDocument2Ptr lpXmlDoc);
		void CreateElemsForPart(const MSXML2::IXMLDOMNodePtr pstNode, CMSF_Profile_PartInfo* pstPartInfo);

	private:
		
		CMSF_Profile_SectionInfoArray m_stSectionInfoList;
		CString* m_strSectionName;
		CString* m_strPartName;
		CString* m_strDataName;
		CString m_strCSPVer;
		CString m_strNotOpenVer;
		CMap<CString, LPCTSTR, DWORD, DWORD> m_ItemTypeMap;
		
		void _GetAttrLabel(const MSXML2::IXMLDOMNodePtr pstNode, CString& strLabel);
		
		void _GetAttrConditionNumber(const MSXML2::IXMLDOMNodePtr pstNode, DWORD& dwConditionNumber);

		void _GetAttrResultNumber(const MSXML2::IXMLDOMNodePtr pstNode,	DWORD& dwResultNumber);
		
		void _GetAttrIndex(const MSXML2::IXMLDOMNodePtr pcNode,	DWORD& dwIndexData);
		
		void _GetTagComment(const MSXML2::IXMLDOMNodePtr pstNode, CString& strComment);
		
		void _GetTagLabel2(const MSXML2::IXMLDOMNodePtr pstNode, CString& strLabel2);
		
		void _DoPart(const MSXML2::IXMLDOMNodePtr pstNode, CMSF_Profile_SectionInfo* pstSectionInfo);
		
		void _DoElem(const MSXML2::IXMLDOMNodePtr pstNode, CMSF_Profile_PartInfo* pstPartInfo);
		
		void _DoItem(const MSXML2::IXMLDOMNodePtr pstNode, CMSF_Profile_ElemInfo* pstElemInfo);
		
		void _DoConditionItem(const MSXML2::IXMLDOMNodePtr pcElemNode, CMSF_Profile_ElemInfo* pcElemInfo);
		
		void _DoEnumItem(const MSXML2::IXMLDOMNodePtr pcElemNode, CMSF_Profile_ElemInfo* pcElemInfo);

		void _DoData(const MSXML2::IXMLDOMNodePtr pstNode, CMSF_Profile_ItemInfo* pstItemInfo);
		
		void _ErrorHandler(void);
		
		DWORD _GetProfileType(const CString& strNameSpace);
		
		void _ConstructTree(const MSXML2::IXMLDOMDocument2Ptr lpXmlDoc);
		
		CString _GetNewVersion(CString strFirstVer, CString strSecondVer);
		
		void _ConvertVersionToNumeric(CString strVer, DWORD	&dwMajor, DWORD	&dwMinor);
		#pragma endregion
	};
	#pragma endregion

	#pragma endregion Class/API use for external	
};

#pragma pack(pop) // ȍ~ɂ͒ǉȂ